;
; Common setup code for ABC800
;

	defc BOFA=65286
	defc EOFA=65288
	defc HEAP=65290
	defc BOTM=65292
	defc TOPM=65294
	defc TOPP=65296

	defc HLBOFA=003Bh	; LD HL,BOFA
	defc IXBOFA=003Fh	; LD IX,BOFA
	defc HLPROG=0044h	; LD HL,BOFA+20 (after header)

	;; First, the ABC800 BAC file header
_header:
	defb 8Fh		; BASIC II
	defb 0
	defb 21h		; Program flags (meaning unclear)
	defb 0
PRGSZ:	defw _end + 7		; Adjust to total file length (7 = trailer)
	defw 0			; Scalar variable area size
	defw 0			; Address for scalar variable area
	defw 0			; Variable count
COMSZ:	defw 0			; COMMON area size (memory reserved @ BOTM)
	defw 0			; COMMON declarations checksum
	defw 0			; Address for the first DEF statement
	defw 0			; Address for the first DATA statement

	;; BASIC bytecode to invoke _start The GOSUB allows the
	;; assembly program to hijack the BASIC flow of control if it
	;; would want to; the BASIC return instruction pointer is
	;; found at offset +4 of the value in SPSAV = FF45h
_basic:
	defb 130		; GOSUB
	defw 1+1		; Skip 1 byte
	defb 146		; END
	defb 221 + 11		; PUSH int 11
	defb 209		; Function call, 1 parameter
	defb 25			; SYS()		SYS(11) = BOFA
	defb 221 + _start	; PUSH int _start
	defb 156		; + int
	defb 209		; Function call, 1 parameter
	defb 23			; CALL()
	defb 184		; POP int (end expression)
	defb 160		; RETURN
