#!/bin/sh -xe
#
# Run this script to regenerate autoconf files
#
mkdir -p autoconf autoconf/aux config
autolib="`automake --print-libdir`"
for prg in install-sh compile config.guess config.sub; do
    cp -u "$autolib"/"$prg" autoconf/aux
done
rm -f autoconf/aclocal.m4
mkdir -p autoconf/m4.old autoconf/m4
mv -f autoconf/m4/*.m4 autoconf/m4.old/ || true
ACLOCAL_PATH="${ACLOCAL_PATH}${ACLOCAL_PATH:+:}`pwd`/autoconf/m4.old"
export ACLOCAL_PATH
aclocal --install --output=autoconf/aclocal.m4 -I autoconf/m4
test -f autoconf/aclocal.m4
rm -rf autoconf/m4.old
autoheader -B autoconf
autoconf -B autoconf
rm -rf autom4te.cache config.log config.status config/config.h Makefile
